diff -ruN vdr-1.3.46/libsi/si.c vdr-1.3.47/libsi/si.c
--- vdr-1.3.46/libsi/si.c	2006-02-18 11:38:20.000000000 +0100
+++ vdr-1.3.47/libsi/si.c	2006-04-14 12:53:44.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.c 1.15 2006/02/18 10:38:20 kls Exp $
+ *   $Id: si.c 1.16 2006/04/14 10:53:44 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -373,6 +373,9 @@
          case MultilingualComponentDescriptorTag:
             d=new MultilingualComponentDescriptor();
             break;
+         case PrivateDataSpecifierDescriptorTag:
+            d=new PrivateDataSpecifierDescriptor();
+            break;
          case ServiceMoveDescriptorTag:
             d=new ServiceMoveDescriptor();
             break;
@@ -400,9 +403,16 @@
          case ParentalRatingDescriptorTag:
             d=new ParentalRatingDescriptor();
             break;
+         case TeletextDescriptorTag:
+         case VBITeletextDescriptorTag:
+            d=new TeletextDescriptor();
+            break;
          case ApplicationSignallingDescriptorTag:
             d=new ApplicationSignallingDescriptor();
             break;
+         case LocalTimeOffsetDescriptorTag:
+            d=new LocalTimeOffsetDescriptor();
+            break;
          case LinkageDescriptorTag:
             d=new LinkageDescriptor();
             break;
@@ -412,6 +422,9 @@
          case PDCDescriptorTag:
             d=new PDCDescriptor();
             break;
+         case AncillaryDataDescriptorTag:
+            d=new AncillaryDataDescriptor();
+            break;
 
          //note that it is no problem to implement one
          //of the unimplemented descriptors.
@@ -436,13 +449,9 @@
          //defined in ETSI EN 300 468
          case StuffingDescriptorTag:
          case VBIDataDescriptorTag:
-         case VBITeletextDescriptorTag:
          case CountryAvailabilityDescriptorTag:
          case MocaicDescriptorTag:
-         case TeletextDescriptorTag:
          case TelephoneDescriptorTag:
-         case LocalTimeOffsetDescriptorTag:
-         case PrivateDataSpecifierDescriptorTag:
          case CellListDescriptorTag:
          case CellFrequencyLinkDescriptorTag:
          case ServiceAvailabilityDescriptorTag:
@@ -453,7 +462,6 @@
          case CaSystemDescriptorTag:
          case AC3DescriptorTag:
          case DSNGDescriptorTag:
-         case AncillaryDataDescriptorTag:
          case AnnouncementSupportDescriptorTag:
          case AdaptationFieldDataDescriptorTag:
          case TransportStreamDescriptorTag:
@@ -500,6 +508,27 @@
             break;
       }
       break;
+   case PCIT:
+      switch ((DescriptorTag)da.getData<DescriptorHeader>()->descriptor_tag) {
+         case ContentDescriptorTag:
+            d=new ContentDescriptor();
+            break;
+         case ShortEventDescriptorTag:
+            d=new ShortEventDescriptor();
+            break;
+         case ExtendedEventDescriptorTag:
+            d=new ExtendedEventDescriptor();
+            break;
+         case PremiereContentTransmissionDescriptorTag:
+            d=new PremiereContentTransmissionDescriptor();
+            break;
+         default:
+            if (!returnUnimplemetedDescriptor)
+               return 0;
+            d=new UnimplementedDescriptor();
+            break;
+      }
+      break;
    }
    d->setData(da);
    return d;
diff -ruN vdr-1.3.46/libsi/si.h vdr-1.3.47/libsi/si.h
--- vdr-1.3.46/libsi/si.h	2006-02-18 11:38:20.000000000 +0100
+++ vdr-1.3.47/libsi/si.h	2006-04-14 12:53:44.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.h 1.13 2006/02/18 10:38:20 kls Exp $
+ *   $Id: si.h 1.14 2006/04/14 10:53:44 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -43,7 +43,8 @@
                TableIdTOT = 0x73, //time offset section
                TableIdDIT = 0x7E, //discontinuity information section
                TableIdSIT = 0x7F, //service information section
-               TableIdAIT = 0x74  //application information section
+               TableIdAIT = 0x74, //application information section
+               TableIdPremiereCIT = 0xA0 //premiere content information section
              };
 
 
@@ -139,13 +140,15 @@
                MHP_PrefetchDescriptorTag = 0x0C,
                MHP_DelegatedApplicationDescriptorTag = 0x0E,
                MHP_ApplicationStorageDescriptorTag = 0x10,
+  // Premiere private Descriptor Tags
+               PremiereContentTransmissionDescriptorTag = 0xF2,
 
                //a descriptor currently unimplemented in this library
                //the actual value 0xFF is "forbidden" according to the spec.
                UnimplementedDescriptorTag = 0xFF
 };
 
-enum DescriptorTagDomain { SI, MHP };
+enum DescriptorTagDomain { SI, MHP, PCIT };
 
 enum RunningStatus { RunningStatusUndefined = 0,
                      RunningStatusNotRunning = 1,
@@ -411,6 +414,12 @@
    MHP_DescriptorLoop() { domain=MHP; }
 };
 
+//Premiere Content Information Table
+class PCIT_DescriptorLoop : public DescriptorLoop {
+public:
+   PCIT_DescriptorLoop() { domain=PCIT; }
+};
+
 //The content of the ExtendedEventDescriptor may be split over several
 //descriptors if the text is longer than 256 bytes.
 //The following classes provide base functionality to handle this case.
diff -ruN vdr-1.3.46/menu.c vdr-1.3.47/menu.c
--- vdr-1.3.46/menu.c	2006-04-09 16:29:24.000000000 +0200
+++ vdr-1.3.47/menu.c	2006-04-16 14:20:46.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.428 2006/04/09 14:29:24 kls Exp $
+ * $Id: menu.c 1.434 2006/04/16 12:20:46 kls Exp $
  */
 
 #include "menu.h"
@@ -32,6 +32,9 @@
 #define MAXWAIT4EPGINFO   3 // seconds
 #define MODETIMEOUT       3 // seconds
 #define DISKSPACECHEK     5 // seconds between disk space checks in the main menu
+#define NEWTIMERLIMIT   120 // seconds until the start time of a new timer created from the Schedule menu,
+                            // within which it will go directly into the "Edit timer" menu to allow
+                            // further parameter settings
 
 #define MAXRECORDCONTROLS (MAXDEVICES * MAXRECEIVERS)
 #define MAXINSTANTRECTIME (24 * 60 - 1) // 23:59 hours
@@ -1152,9 +1155,10 @@
         }
      else {
         Timers.Add(timer);
-        timer->Matches();
         Timers.SetModified();
         isyslog("timer %s added (active)", *timer->ToDescr());
+        if (timer->Matches(0, false, NEWTIMERLIMIT))
+           return AddSubMenu(new cMenuEditTimer(timer));
         if (HasSubMenu())
            CloseSubMenu();
         if (Update())
@@ -1400,9 +1404,10 @@
         }
      else {
         Timers.Add(timer);
-        timer->Matches();
         Timers.SetModified();
         isyslog("timer %s added (active)", *timer->ToDescr());
+        if (timer->Matches(0, false, NEWTIMERLIMIT))
+           return AddSubMenu(new cMenuEditTimer(timer));
         if (HasSubMenu())
            CloseSubMenu();
         if (Update())
@@ -2031,7 +2036,7 @@
      cRecording *recording = GetRecording(ri);
      if (recording) {
         char *parameter = NULL;
-        asprintf(&parameter, "'%s'", recording->FileName());
+        asprintf(&parameter, "\"%s\"", *strescape(recording->FileName(), "\"$"));
         cMenuCommands *menu;
         eOSState state = AddSubMenu(menu = new cMenuCommands(tr("Recording commands"), &RecordingCommands, parameter));
         free(parameter);
@@ -2299,7 +2304,7 @@
   int numAudioLanguages;
   void Setup(void);
   const char *videoDisplayFormatTexts[3];
-  const char *updateChannelsTexts[5];
+  const char *updateChannelsTexts[6];
 public:
   cMenuSetupDVB(void);
   virtual eOSState ProcessKey(eKeys Key);
@@ -2315,9 +2320,10 @@
   videoDisplayFormatTexts[2] = tr("center cut out");
   updateChannelsTexts[0] = tr("no");
   updateChannelsTexts[1] = tr("names only");
-  updateChannelsTexts[2] = tr("names and PIDs");
-  updateChannelsTexts[3] = tr("add new channels");
-  updateChannelsTexts[4] = tr("add new transponders");
+  updateChannelsTexts[2] = tr("PIDs only");
+  updateChannelsTexts[3] = tr("names and PIDs");
+  updateChannelsTexts[4] = tr("add new channels");
+  updateChannelsTexts[5] = tr("add new transponders");
 
   SetSection(tr("DVB"));
   Setup();
@@ -2334,7 +2340,7 @@
   if (data.VideoFormat == 0)
      Add(new cMenuEditStraItem(tr("Setup.DVB$Video display format"), &data.VideoDisplayFormat, 3, videoDisplayFormatTexts));
   Add(new cMenuEditBoolItem(tr("Setup.DVB$Use Dolby Digital"),     &data.UseDolbyDigital));
-  Add(new cMenuEditStraItem(tr("Setup.DVB$Update channels"),       &data.UpdateChannels, 5, updateChannelsTexts));
+  Add(new cMenuEditStraItem(tr("Setup.DVB$Update channels"),       &data.UpdateChannels, 6, updateChannelsTexts));
   Add(new cMenuEditIntItem( tr("Setup.DVB$Audio languages"),       &numAudioLanguages, 0, I18nNumLanguages));
   for (int i = 0; i < numAudioLanguages; i++)
       Add(new cMenuEditStraItem(tr("Setup.DVB$Audio language"),    &data.AudioLanguages[i], I18nNumLanguages, I18nLanguages()));
@@ -2696,7 +2702,9 @@
 
 eOSState cMenuSetup::Restart(void)
 {
-  if (Interface->Confirm(cRecordControls::Active() ? tr("Recording - restart anyway?") : tr("Really restart?"))) {
+  if (Interface->Confirm(tr("Really restart?"))
+     && (!cRecordControls::Active() || Interface->Confirm(tr("Recording - restart anyway?")))
+     && !cPluginManager::Active(tr("Really restart?"))) {
      cThread::EmergencyExit(true);
      return osEnd;
      }
@@ -3156,6 +3164,10 @@
     case kLeft:
     case kRight|k_Repeat:
     case kRight:
+    case kNext|k_Repeat:
+    case kNext:
+    case kPrev|k_Repeat:
+    case kPrev:
          withInfo = false;
          number = 0;
          if (group < 0) {
@@ -3165,7 +3177,7 @@
             }
          if (group >= 0) {
             int SaveGroup = group;
-            if (NORMALKEY(Key) == kRight)
+            if (NORMALKEY(Key) == kRight || NORMALKEY(Key) == kNext)
                group = Channels.GetNextGroup(group) ;
             else
                group = Channels.GetPrevGroup(group < 1 ? 1 : group);
@@ -3199,6 +3211,8 @@
     case kDown|k_Release:
     case kChanUp|k_Release:
     case kChanDn|k_Release:
+    case kNext|k_Release:
+    case kPrev|k_Release:
          if (!(Key & k_Repeat) && channel && channel->Number() != cDevice::CurrentChannel())
             NewChannel = channel;
          withInfo = true;
@@ -3788,6 +3802,7 @@
   marks.Load(fileName);
   cRecording Recording(fileName);
   cStatus::MsgReplaying(this, Recording.Name(), Recording.FileName(), true);
+  SetTrackDescriptions(false);
 }
 
 cReplayControl::~cReplayControl()
@@ -4143,8 +4158,12 @@
       switch (Key) {
         // Editing:
         case kMarkToggle:      MarkToggle(); break;
+        case kPrev|k_Repeat:
+        case kPrev:
         case kMarkJumpBack|k_Repeat:
         case kMarkJumpBack:    MarkJump(false); break;
+        case kNext|k_Repeat:
+        case kNext:
         case kMarkJumpForward|k_Repeat:
         case kMarkJumpForward: MarkJump(true); break;
         case kMarkMoveBack|k_Repeat:
diff -ruN vdr-1.3.46/menuitems.c vdr-1.3.47/menuitems.c
--- vdr-1.3.46/menuitems.c	2006-04-09 15:10:02.000000000 +0200
+++ vdr-1.3.47/menuitems.c	2006-04-14 12:41:28.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 1.36 2006/04/09 13:10:02 kls Exp $
+ * $Id: menuitems.c 1.42 2006/04/14 10:41:28 kls Exp $
  */
 
 #include "menuitems.h"
@@ -23,22 +23,18 @@
 
 cMenuEditItem::cMenuEditItem(const char *Name)
 {
-  name = strdup(Name);
-  value = NULL;
+  name = strdup(Name ? Name : "???");
 }
 
 cMenuEditItem::~cMenuEditItem()
 {
   free(name);
-  free(value);
 }
 
 void cMenuEditItem::SetValue(const char *Value)
 {
-  free(value);
-  value = strdup(Value);
   char *buffer = NULL;
-  asprintf(&buffer, "%s:\t%s", name, value);
+  asprintf(&buffer, "%s:\t%s", name, Value);
   SetText(buffer, false);
   cStatus::MsgOsdCurrentItem(buffer);
 }
@@ -102,7 +98,7 @@
             if (*value > max) { *value = max; Set(); }
             return state;
        }
-     if ((!fresh || min <= newValue) && newValue <= max) {
+     if (newValue != *value && (!fresh || min <= newValue) && newValue <= max) {
         *value = newValue;
         Set();
         }
@@ -205,7 +201,7 @@
 :cMenuEditItem(Name)
 {
   value = Value;
-  allowed = strdup(Allowed);
+  allowed = strdup(Allowed ? Allowed : "");
   current = strchr(allowed, *Value);
   if (!current)
      current = allowed;
@@ -254,7 +250,7 @@
   orgValue = NULL;
   value = Value;
   length = Length;
-  allowed = strdup(Allowed);
+  allowed = strdup(Allowed ? Allowed : "");
   pos = -1;
   insert = uppercase = false;
   newchar = true;
@@ -572,7 +568,7 @@
      snprintf(buf, sizeof(buf), "%d %s", *value, channel ? channel->Name() : "");
      SetValue(buf);
      }
-  else
+  else if (noneString)
      SetValue(noneString);
 }
 
@@ -602,7 +598,7 @@
 // --- cMenuEditTranItem -----------------------------------------------------
 
 cMenuEditTranItem::cMenuEditTranItem(const char *Name, int *Value, int *Source)
-:cMenuEditChanItem(Name, &number)
+:cMenuEditChanItem(Name, &number, "-")
 {
   number = 0;
   source = Source;
@@ -626,6 +622,10 @@
      *source = channel->Source();
      *transponder = channel->Transponder();
      }
+  else {
+     *source = 0;
+     *transponder = 0;
+     }
   return state;
 }
 
diff -ruN vdr-1.3.46/menuitems.h vdr-1.3.47/menuitems.h
--- vdr-1.3.46/menuitems.h	2006-04-09 14:56:48.000000000 +0200
+++ vdr-1.3.47/menuitems.h	2006-04-14 12:01:47.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.h 1.19 2006/04/09 12:56:48 kls Exp $
+ * $Id: menuitems.h 1.20 2006/04/14 10:01:47 kls Exp $
  */
 
 #ifndef __MENUITEMS_H
@@ -17,7 +17,6 @@
 class cMenuEditItem : public cOsdItem {
 private:
   char *name;
-  char *value;
 public:
   cMenuEditItem(const char *Name);
   ~cMenuEditItem();
diff -ruN vdr-1.3.46/newplugin vdr-1.3.47/newplugin
--- vdr-1.3.46/newplugin	2005-11-11 14:20:14.000000000 +0100
+++ vdr-1.3.47/newplugin	2006-04-17 11:49:13.000000000 +0200
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 1.22 2005/11/11 13:20:14 kls Exp $
+# $Id: newplugin 1.26 2006/04/17 09:49:13 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -75,7 +75,6 @@
 
 ### The directory environment:
 
-DVBDIR = ../../../../DVB
 VDRDIR = ../../..
 LIBDIR = ../../lib
 TMPDIR = /tmp
@@ -84,9 +83,9 @@
 
 -include \$(VDRDIR)/Make.config
 
-### The version number of VDR (taken from VDR's "config.h"):
+### The version number of VDR's plugin API (taken from VDR's "config.h"):
 
-VDRVERSION = \$(shell grep 'define VDRVERSION ' \$(VDRDIR)/config.h | awk '{ print \$\$3 }' | sed -e 's/"//g')
+APIVERSION = \$(shell grep 'define APIVERSION ' \$(VDRDIR)/config.h | awk '{ print \$\$3 }' | sed -e 's/"//g')
 
 ### The name of the distribution archive:
 
@@ -95,7 +94,7 @@
 
 ### Includes and Defines (add further entries here):
 
-INCLUDES += -I\$(VDRDIR)/include -I\$(DVBDIR)/include
+INCLUDES += -I\$(VDRDIR)/include
 
 DEFINES += -D_GNU_SOURCE -DPLUGIN_NAME_I18N='"\$(PLUGIN)"'
 
@@ -123,7 +122,7 @@
 
 libvdr-\$(PLUGIN).so: \$(OBJS)
 	\$(CXX) \$(CXXFLAGS) -shared \$(OBJS) -o \$\@
-	\@cp \$\@ \$(LIBDIR)/\$\@.\$(VDRVERSION)
+	\@cp \$\@ \$(LIBDIR)/\$\@.\$(APIVERSION)
 
 dist: clean
 	\@-rm -rf \$(TMPDIR)/\$(ARCHIVE)
@@ -166,6 +165,8 @@
   virtual bool Start(void);
   virtual void Stop(void);
   virtual void Housekeeping(void);
+  virtual void MainThreadHook(void);
+  virtual cString Active(void);
   virtual const char *MainMenuEntry(void) { return MAINMENUENTRY; }
   virtual cOsdObject *MainMenuAction(void);
   virtual cMenuSetupPage *SetupMenu(void);
@@ -221,6 +222,18 @@
   // Perform any cleanup or other regular tasks.
 }
 
+void cPlugin${PLUGIN_CLASS}::MainThreadHook(void)
+{
+  // Perform actions in the context of the main program thread.
+  // WARNING: Use with great care - see PLUGINS.html!
+}
+
+cString cPlugin${PLUGIN_CLASS}::Active(void)
+{
+  // Return a message string if shutdown should be postponed
+  return NULL;
+}
+
 cOsdObject *cPlugin${PLUGIN_CLASS}::MainMenuAction(void)
 {
   // Perform the action when selected from the main VDR menu.
diff -ruN vdr-1.3.46/nit.c vdr-1.3.47/nit.c
--- vdr-1.3.46/nit.c	2004-10-17 14:00:54.000000000 +0200
+++ vdr-1.3.47/nit.c	2006-04-15 16:10:42.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: nit.c 1.10 2004/10/17 12:00:54 kls Exp $
+ * $Id: nit.c 1.11 2006/04/15 14:10:42 kls Exp $
  */
 
 #include "nit.h"
@@ -116,12 +116,12 @@
                  bool found = false;
                  for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
                      if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
-                        if (Setup.UpdateChannels >= 4)
+                        if (Setup.UpdateChannels >= 5)
                            Channel->SetSatTransponderData(Source, Frequency, Polarization, SymbolRate, CodeRate);
                         found = true;
                         }
                      }
-                 if (!found && Setup.UpdateChannels >= 4) {
+                 if (!found && Setup.UpdateChannels >= 5) {
                     cChannel *Channel = new cChannel;
                     Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
                     if (Channel->SetSatTransponderData(Source, Frequency, Polarization, SymbolRate, CodeRate))
@@ -151,12 +151,12 @@
                  bool found = false;
                  for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
                      if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
-                        if (Setup.UpdateChannels >= 4)
+                        if (Setup.UpdateChannels >= 5)
                            Channel->SetCableTransponderData(Source, Frequency, Modulation, SymbolRate, CodeRate);
                         found = true;
                         }
                      }
-                 if (!found && Setup.UpdateChannels >= 4) {
+                 if (!found && Setup.UpdateChannels >= 5) {
                     cChannel *Channel = new cChannel;
                     Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
                     if (Channel->SetCableTransponderData(Source, Frequency, Modulation, SymbolRate, CodeRate))
@@ -193,12 +193,12 @@
                  bool found = false;
                  for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
                      if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
-                        if (Setup.UpdateChannels >= 4)
+                        if (Setup.UpdateChannels >= 5)
                            Channel->SetTerrTransponderData(Source, Frequency, Bandwidth, Constellation, Hierarchy, CodeRateHP, CodeRateLP, GuardInterval, TransmissionMode);
                         found = true;
                         }
                      }
-                 if (!found && Setup.UpdateChannels >= 4) {
+                 if (!found && Setup.UpdateChannels >= 5) {
                     cChannel *Channel = new cChannel;
                     Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
                     if (Channel->SetTerrTransponderData(Source, Frequency, Bandwidth, Constellation, Hierarchy, CodeRateHP, CodeRateLP, GuardInterval, TransmissionMode))
diff -ruN vdr-1.3.46/plugin.c vdr-1.3.47/plugin.c
--- vdr-1.3.46/plugin.c	2006-04-09 16:16:17.000000000 +0200
+++ vdr-1.3.47/plugin.c	2006-04-17 11:20:05.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.c 1.18 2006/04/09 14:16:17 kls Exp $
+ * $Id: plugin.c 1.22 2006/04/17 09:20:05 kls Exp $
  */
 
 #include "plugin.h"
@@ -14,6 +14,7 @@
 #include <stdlib.h>
 #include <time.h>
 #include "config.h"
+#include "interface.h"
 
 #define LIBVDR_PREFIX  "libvdr-"
 #define SO_INDICATOR   ".so."
@@ -69,6 +70,15 @@
 {
 }
 
+void cPlugin::MainThreadHook(void)
+{
+}
+
+cString cPlugin::Active(void)
+{
+  return NULL;
+}
+
 const char *cPlugin::MainMenuEntry(void)
 {
   return NULL;
@@ -284,7 +294,7 @@
               if (p) {
                  *p = 0;
                  p += strlen(SO_INDICATOR);
-                 if (strcmp(p, VDRVERSION) == 0) {
+                 if (strcmp(p, APIVERSION) == 0) {
                     char *name = e->d_name + strlen(LIBVDR_PREFIX);
                     if (strcmp(name, "*") != 0) { // let's not get into a loop!
                        AddPlugin(e->d_name + strlen(LIBVDR_PREFIX));
@@ -300,7 +310,7 @@
   if (p)
      *p = 0;
   char *buffer = NULL;
-  asprintf(&buffer, "%s/%s%s%s%s", directory, LIBVDR_PREFIX, s, SO_INDICATOR, VDRVERSION);
+  asprintf(&buffer, "%s/%s%s%s%s", directory, LIBVDR_PREFIX, s, SO_INDICATOR, APIVERSION);
   dlls.Add(new cDll(buffer, Args));
   free(buffer);
   free(s);
@@ -364,6 +374,32 @@
      }
 }
 
+void cPluginManager::MainThreadHook(void)
+{
+  for (cDll *dll = pluginManager->dlls.First(); dll; dll = pluginManager->dlls.Next(dll)) {
+      cPlugin *p = dll->Plugin();
+      if (p)
+         p->MainThreadHook();
+      }
+}
+
+bool cPluginManager::Active(const char *Prompt)
+{
+  if (pluginManager) {
+     for (cDll *dll = pluginManager->dlls.First(); dll; dll = pluginManager->dlls.Next(dll)) {
+         cPlugin *p = dll->Plugin();
+         if (p) {
+            cString s = p->Active();
+            if (!isempty(*s)) {
+               if (!Prompt || !Interface->Confirm(cString::sprintf("%s - %s", *s, Prompt)))
+                  return true;
+               }
+            }
+         }
+     }
+  return false;
+}
+
 bool cPluginManager::HasPlugins(void)
 {
   return pluginManager && pluginManager->dlls.Count();
@@ -424,9 +460,13 @@
       }
 }
 
-void cPluginManager::Shutdown(void)
+void cPluginManager::Shutdown(bool Log)
 {
   cDll *dll;
-  while ((dll = dlls.Last()) != NULL)
+  while ((dll = dlls.Last()) != NULL) {
+        cPlugin *p = dll->Plugin();
+        if (p && Log)
+           isyslog("deleting plugin: %s", p->Name());
         dlls.Del(dll);
+        }
 }
diff -ruN vdr-1.3.46/plugin.h vdr-1.3.47/plugin.h
--- vdr-1.3.46/plugin.h	2005-08-27 18:13:17.000000000 +0200
+++ vdr-1.3.47/plugin.h	2006-04-17 11:18:16.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.h 1.10 2005/08/27 16:13:17 kls Exp $
+ * $Id: plugin.h 1.13 2006/04/17 09:18:16 kls Exp $
  */
 
 #ifndef __PLUGIN_H
@@ -39,6 +39,8 @@
   virtual bool Start(void);
   virtual void Stop(void);
   virtual void Housekeeping(void);
+  virtual void MainThreadHook(void);
+  virtual cString Active(void);
 
   virtual const char *MainMenuEntry(void);
   virtual cOsdObject *MainMenuAction(void);
@@ -89,13 +91,15 @@
   bool InitializePlugins(void);
   bool StartPlugins(void);
   void Housekeeping(void);
+  void MainThreadHook(void);
+  static bool Active(const char *Prompt = NULL);
   static bool HasPlugins(void);
   static cPlugin *GetPlugin(int Index);
   static cPlugin *GetPlugin(const char *Name);
   static cPlugin *CallFirstService(const char *Id, void *Data = NULL);
   static bool CallAllServices(const char *Id, void *Data = NULL);
   void StopPlugins(void);
-  void Shutdown(void);
+  void Shutdown(bool Log = false);
   };
 
 #endif //__PLUGIN_H
diff -ruN vdr-1.3.46/recording.c vdr-1.3.47/recording.c
--- vdr-1.3.46/recording.c	2006-04-09 15:49:51.000000000 +0200
+++ vdr-1.3.47/recording.c	2006-04-17 14:47:59.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 1.144 2006/04/09 13:49:51 kls Exp $
+ * $Id: recording.c 1.146 2006/04/17 12:47:59 kls Exp $
  */
 
 #include "recording.h"
@@ -192,7 +192,7 @@
      }
 }
 
-// --- cResumeFile ------------------------------------------------------------
+// --- cResumeFile -----------------------------------------------------------
 
 cResumeFile::cResumeFile(const char *FileName)
 {
@@ -389,7 +389,10 @@
 struct tCharExchange { char a; char b; };
 tCharExchange CharExchange[] = {
   { '~',  '/'    },
+  { '/',  '~'    },
   { ' ',  '_'    },
+  // backwards compatibility:
+  { '\'', '\''   },
   { '\'', '\x01' },
   { '/',  '\x02' },
   { 0, 0 }
diff -ruN vdr-1.3.46/remote.c vdr-1.3.47/remote.c
--- vdr-1.3.46/remote.c	2006-01-29 15:43:07.000000000 +0100
+++ vdr-1.3.47/remote.c	2006-04-17 10:58:28.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 1.49 2006/01/29 14:43:07 kls Exp $
+ * $Id: remote.c 1.50 2006/04/17 08:58:28 kls Exp $
  */
 
 #include "remote.h"
@@ -145,10 +145,23 @@
   return false;
 }
 
-void cRemote::CallPlugin(const char *Plugin)
+bool cRemote::CallPlugin(const char *Plugin)
 {
-  plugin = Plugin;
-  Put(k_Plugin);
+  cMutexLock MutexLock(&mutex);
+  if (!plugin) {
+     plugin = Plugin;
+     Put(k_Plugin);
+     return true;
+     }
+  return false;
+}
+
+const char *cRemote::GetPlugin(void)
+{
+  cMutexLock MutexLock(&mutex);
+  const char *p = plugin;
+  plugin = NULL;
+  return p;
 }
 
 bool cRemote::HasKeys(void)
diff -ruN vdr-1.3.46/remote.h vdr-1.3.47/remote.h
--- vdr-1.3.46/remote.h	2006-03-31 16:18:44.000000000 +0200
+++ vdr-1.3.47/remote.h	2006-04-17 10:59:48.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.h 1.34 2006/03/31 14:18:44 kls Exp $
+ * $Id: remote.h 1.35 2006/04/17 08:59:48 kls Exp $
  */
 
 #ifndef __REMOTE_H
@@ -46,11 +46,18 @@
   static void Clear(void);
   static bool Put(eKeys Key, bool AtFront = false);
   static bool PutMacro(eKeys Key);
-  static void CallPlugin(const char *Plugin);
+  static bool CallPlugin(const char *Plugin);
       ///< Initiates calling the given plugin's main menu function.
       ///< The Plugin parameter is the name of the plugin, and must be
-      ///< a static string.
-  static const char *GetPlugin(void) { return plugin; }
+      ///< a static string. Returns true if the plugin call was successfully
+      ///< initiated (the actual call to the plugin's main menu function
+      ///< will take place some time later, during the next execution
+      ///< of VDR's main loop). If there is already a plugin call pending
+      ///< false will be returned and the caller should try again later.
+  static const char *GetPlugin(void);
+      ///< Returns the name of the plugin that was set with a previous
+      ///< call to CallPlugin(). The internally stored pointer to the
+      ///< plugin name will be reset to NULL by this call.
   static bool HasKeys(void);
   static eKeys Get(int WaitMs = 1000, char **UnknownCode = NULL);
   };
diff -ruN vdr-1.3.46/remux.c vdr-1.3.47/remux.c
--- vdr-1.3.46/remux.c	2006-03-25 13:27:30.000000000 +0100
+++ vdr-1.3.47/remux.c	2006-04-17 14:48:12.000000000 +0200
@@ -11,7 +11,7 @@
  * The cRepacker family's code was originally written by Reinhard Nissl <rnissl@gmx.de>,
  * and adapted to the VDR coding style by Klaus.Schmidinger@cadsoft.de.
  *
- * $Id: remux.c 1.55 2006/03/25 12:27:30 kls Exp $
+ * $Id: remux.c 1.56 2006/04/17 12:48:12 kls Exp $
  */
 
 #include "remux.h"
@@ -148,7 +148,7 @@
   return n;
 }
 
-// --- cCommonRepacker --------------------------------------------------------
+// --- cCommonRepacker -------------------------------------------------------
 
 class cCommonRepacker : public cRepacker {
 protected:
diff -ruN vdr-1.3.46/sdt.c vdr-1.3.47/sdt.c
--- vdr-1.3.46/sdt.c	2005-08-27 11:27:47.000000000 +0200
+++ vdr-1.3.47/sdt.c	2006-04-15 16:12:21.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sdt.c 1.15 2005/08/27 09:27:47 kls Exp $
+ * $Id: sdt.c 1.16 2006/04/15 14:12:21 kls Exp $
  */
 
 #include "sdt.h"
@@ -78,7 +78,7 @@
                         char *pp = compactspace(ProviderNameBuf);
                         if (channel) {
                            channel->SetId(sdt.getOriginalNetworkId(), sdt.getTransportStreamId(), SiSdtService.getServiceId());
-                           if (Setup.UpdateChannels >= 1)
+                           if (Setup.UpdateChannels == 1 || Setup.UpdateChannels >= 3)
                               channel->SetName(pn, ps, pp);
                            // Using SiSdtService.getFreeCaMode() is no good, because some
                            // tv stations set this flag even for non-encrypted channels :-(
@@ -86,7 +86,7 @@
                            // and would have been overwritten with real CA values later:
                            // channel->SetCa(SiSdtService.getFreeCaMode() ? 0xFFFF : 0);
                            }
-                        else if (*pn && Setup.UpdateChannels >= 3) {
+                        else if (*pn && Setup.UpdateChannels >= 4) {
                            channel = Channels.NewChannel(Channel(), pn, ps, pp, sdt.getOriginalNetworkId(), sdt.getTransportStreamId(), SiSdtService.getServiceId());
                            patFilter->Trigger();
                            }
@@ -111,7 +111,7 @@
                  SI::NVODReferenceDescriptor::Service Service;
                  for (SI::Loop::Iterator it; nrd->serviceLoop.getNext(Service, it); ) {
                      cChannel *link = Channels.GetByChannelID(tChannelID(Source(), Service.getOriginalNetworkId(), Service.getTransportStream(), Service.getServiceId()));
-                     if (!link && Setup.UpdateChannels >= 3) {
+                     if (!link && Setup.UpdateChannels >= 4) {
                         link = Channels.NewChannel(Channel(), "NVOD", "", "", Service.getOriginalNetworkId(), Service.getTransportStream(), Service.getServiceId());
                         patFilter->Trigger();
                         }
